package org.jboss.security.auth.spi;

 
import java.security.AccessController;
import java.security.PrivilegedActionException;
import java.security.PrivilegedExceptionAction;

 
import javax.management.MBeanServer;
import javax.management.ObjectName;

 
import org.apache.log4j.Logger;
import org.jboss.mx.util.MBeanServerLocator;

 
class DecodeAction implements PrivilegedExceptionAction<Object> {
    protected static Logger _logger = Logger.getLogger(DecodeAction.class);
    


 
    String password;
    ObjectName serviceName;

 
    DecodeAction(String password, ObjectName serviceName) {
        _logger.debug("DecodeAction password " + password + " serviceName " +serviceName);
        this.password = password;
        this.serviceName = serviceName;

    }

 
    /**
     * 
     * @return
     * @throws Exception
     */
    public Object run() throws Exception {
        _logger.debug("DecodeAction run fixedDecode64 " + password );

 
        // Invoke the decodeb64 op
        byte[] secret = decode64(password);

 
        // Convert to UTF-8 base char array
        String secretPassword = new String(secret, "UTF-8");
        
        //_logger.debug( " secretPassword " +secretPassword);
        return secretPassword.toCharArray();
    }

 
 
    private byte[] decode64(String secret) throws Exception {

 
        
        MBeanServer server = MBeanServerLocator.locateJBoss();
        Object[] params = {secret};
        String[] signature = {"java.lang.String"};
         byte[] decoded = ( byte[]) server.invoke(serviceName, "decode64", 
                                          params, signature);

 
         return decoded;
    }

 
    protected static char[] decode(String password, ObjectName serviceName)

            throws Exception {
        DecodeAction action = new DecodeAction(password, serviceName);
        try {
            char[] decode = (char[]) AccessController.doPrivileged(action);
            return decode;
        } catch (PrivilegedActionException e) {
            _logger.debug("package access decode caught an exception ",e );
            throw e.getException();
        }
    }
}
